// OptionListBox.cpp : implementation file
//

#include "stdafx.h"
#include "MakeTerrain.h"
#include "JeremyBitmapList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Decallage du text par rapport  l'image ou  la case
#define DECTEXT		2

// Dimension d'une case.
#define BOXX	15
#define BOXY	15
#define BORD	20
#define COLOR_ITEM_HEIGHT   20



/////////////////////////////////////////////////////////////////////////////
// CJeremyBitmapList

CJeremyBitmapList::CJeremyBitmapList()
{
	sizebmp.cx = 100;
	sizebmp.cy = 100;
}

CJeremyBitmapList::~CJeremyBitmapList()
{
}


BEGIN_MESSAGE_MAP(CJeremyBitmapList, CListBox)
	//{{AFX_MSG_MAP(CJeremyBitmapList)
	ON_WM_SIZE ()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJeremyBitmapList message handlers



int CJeremyBitmapList :: AddItem (CString str,long IdDessin,long IdVersion)
{
	ListData * pt;
	pt = new ListData ();

	pt->SetTitle (str);
	pt->SetIdDessin (IdDessin);
	pt->SetIdVersion (IdVersion);
	pt->SetHbitmap (NULL);
	
	// Ajouter l'enregistrement
	return AddString ((LPCTSTR) pt);
}




/////////////////////////////////////////////////////////////////////////////




// DRAWITEMSTRUCT
void CJeremyBitmapList::DrawItem(LPDRAWITEMSTRUCT lpDIS)
{
	CDC* pDC = CDC::FromHandle(lpDIS->hDC);
	COLORREF cr = RGB (255,0,0); // RGB in item data
	ListData * pt;
	RECT rc;
	rc = lpDIS->rcItem;

	pt = (ListData *) lpDIS->itemData;
	
	// Valeur de pt nulle alors on ne fait rien
	// Pas de dessin
	if (!pt) return;


	// Dessiner les images seulement quand une selection
	// a change ou quand on doit tout redessiner
	// Ou quand il a perdu le focus
	if ((lpDIS->itemAction & ODA_SELECT)
		|| (lpDIS->itemAction & ODA_DRAWENTIRE )
		|| (lpDIS->itemAction & ODA_FOCUS ))
	{
		DrawImage (pDC,rc,pt->GetHbitmap (),(lpDIS->itemState & ODS_SELECTED) ? TRUE : FALSE);
		DrawInfo (pDC,rc,pt,(lpDIS->itemState & ODS_SELECTED) ? TRUE : FALSE);
	}

	
	// L'item a le focus
	if ((lpDIS->itemAction & ODA_FOCUS) &&
		(lpDIS->itemState & ODS_FOCUS))
		pDC->DrawFocusRect		(&rc);

}

void CJeremyBitmapList :: DrawInfo (CDC * pDC,RECT rcitem,ListData * pt,BOOL bSelected)
{
	UINT TextStyle = DT_CENTER | DT_VCENTER|DT_SINGLELINE;
	RECT rc;
	int prev;
	COLORREF prevTextColor;

	prev = pDC->SetBkMode (TRANSPARENT);
	
	if (bSelected) prevTextColor = pDC->SetTextColor (RGB (255,255,255));

	rc = rcitem;
	rc.bottom = rc.top + BORD;
	pDC->DrawText (pt->GetTitle (),pt->GetTitle ().GetLength (),&rc,TextStyle);

	rc = rcitem;
	rc.top = rc.bottom - BORD;
	pDC->DrawText (pt->GetBmpPath (),pt->GetBmpPath ().GetLength (),&rc,TextStyle);
	
	if (bSelected) pDC->SetTextColor (prevTextColor);
	pDC->SetBkMode (prev);

}


// Cette fonction est appele lorsque que l'on
// a une listbox avec un triage des donnes.
int CJeremyBitmapList::CompareItem(LPCOMPAREITEMSTRUCT lpCIS)
{
	char * str1;
	char * str2;
	int ret;
	str1 = (char *) lpCIS->itemData1;
	str2 = (char *) lpCIS->itemData2;

	ret = strcmp (str1,str2);
	if (!ret) return 0;
	if (ret < 0) return -1;
	return 1;
}



void CJeremyBitmapList :: SetBmpPath (int index,CString BmpPath)
{
	DWORD ret;
	ListData * pt;

	ret = GetItemData (index);
	if (ret == LB_ERR) return;

	// Pas d'erreur alors on traite.
	pt = (ListData * ) ret;
	if (!pt) return;
	pt->SetBmpPath (BmpPath);
	pt->SetHbitmap (LoadBitmapFile (BmpPath));
}


HBITMAP CJeremyBitmapList :: GetHbitmap (int index)
{
	DWORD ret;
	ListData * pt;

	ret = GetItemData (index);
	if (ret == LB_ERR) return NULL;

	// Pas d'erreur alors on traite.
	pt = (ListData * ) ret;
	if (!pt) return NULL;
	return pt->GetHbitmap ();
}


void CJeremyBitmapList :: SetBmpSize (int larg, int haut)
{
	// CListBox
	sizebmp.cx = larg;
	sizebmp.cy = haut;
	SetItemHeight (0,sizebmp.cy+2*BORD);
}


// Permet de charger un bitmap depuis un fichier
HBITMAP CJeremyBitmapList :: LoadBitmapFile (CString FileName)
{
	// Lire le bitmap nuage
	if (!IsFileExist (FileName)) return NULL;
	HBITMAP hbmp;
	hbmp = (HBITMAP) LoadImage(AfxGetInstanceHandle (),FileName,IMAGE_BITMAP,0,0,LR_LOADFROMFILE);
	return hbmp;
}


BOOL CJeremyBitmapList :: IsFileExist (CString FileName)
{
	BOOL ret;
	CFile File;
	ret = File.Open (FileName,CFile::modeRead);
	if (ret) File.Close ();
	return ret;
}

void CJeremyBitmapList :: DeleteItem( LPDELETEITEMSTRUCT lpDeleteItemStruct )
{
	ListData * pt;

	pt = (ListData *) lpDeleteItemStruct->itemData;
	if (pt->GetHbitmap ()) 
	{
		DeleteObject (pt->GetHbitmap ());
	}
	delete pt;
}



void CJeremyBitmapList :: DrawImage (CDC * pDC,RECT &rcitem,HBITMAP bmp,BOOL bSelected)
{
	RECT rc,rcclient;
	CDC hdc;
	CBitmap * pBmp;
	int xdep,ydep;
	SIZE sizetmp;

	

	hdc.CreateCompatibleDC (NULL);
	
	// Prise des dimensions du controle
	GetClientRect (&rcclient);

	// Initialisation des rectangle de dessin
	rc = rcitem;
	rc.right = rcclient.right;


	// Remplir la couleur du fond
	COLORREF rgb = (bSelected) ? GetSysColor (COLOR_HIGHLIGHT) : RGB (192,192,192);
	CBrush hbr (rgb), * old;
	old = (CBrush *) pDC->SelectObject (&hbr);
	pDC->FillRect (&rc,&hbr);
	pDC->SelectObject (old);


	if (bSelected)
	{
		rc.bottom -= 1;
		rc.right  -= 1;
		pDC->Draw3dRect (&rc,RGB (100,100,100),RGB (255,255,255));
	}
	else
	{
		rc.left += 1;
		rc.top  += 1;
		pDC->Draw3dRect (&rc,RGB (255,255,255),RGB (100,100,100));
	}

	// Si bmp est null alors on ne fait rien
	if (!bmp) return;
	pBmp = CBitmap :: FromHandle (bmp);

	// Si le pointeur FromHandle bitmap est NUUL alors on ne fait rien
	if (!pBmp) return;
		
	// Prise des dimension du bitmap
	BITMAP bm;
	pBmp->GetBitmap (&bm);

	// On mmorise les taille dans un tampon temporaire
	// puis on modifie ces donnes temp si les tailles
	// du dessins est infrieur  la taille demand en visu.
	sizetmp = sizebmp;
	if (bm.bmHeight <= sizebmp.cy) sizetmp.cy = bm.bmHeight;
	if (bm.bmWidth <=  sizebmp.cx) sizetmp.cx = bm.bmWidth;

	// Calcul des coordonnes du bitmap
	xdep = (rcclient.right - sizetmp.cx) / 2;
	ydep = rcitem.top + (GetItemHeight (0) - sizetmp.cy) / 2;

	// Desinner le bitmap
	hdc.SelectObject (pBmp);

	pDC->StretchBlt (
		xdep,ydep,sizetmp.cx,sizetmp.cy,
		&hdc,0,0,bm.bmWidth,bm.bmHeight,SRCCOPY);

}

void CJeremyBitmapList::OnSize(UINT nType, int cx, int cy) 
{
	RedrawWindow ();
}


long CJeremyBitmapList :: GetIdDessin (int index)
{
	ListData * pt = NULL;
	pt = (ListData *) GetItemData (index);
	if (!pt) return -1;
	return pt->GetIdDessin ();

}

long CJeremyBitmapList :: GetIdVersion (int index)
{
	ListData * pt = NULL;
	pt = (ListData *) GetItemData (index);
	
	if (!pt) return -1;
	return pt->GetIdVersion ();
}


// Renvoit le nom d'un fichier bitmap en fonction de son index
HBITMAP CJeremyBitmapList :: GetFileName (DWORD index)
{
	ListData * pt = NULL;
	pt = (ListData *) GetItemData (index);
	if (!pt) return NULL;
	return pt->GetHbitmap ();
}

CString CJeremyBitmapList :: GetPathFileName (DWORD index)
{
	CString str;
	ListData * pt = NULL;
	pt = (ListData *) GetItemData (index);
	if (!pt) return str;
	str = pt->GetBmpPath ();
	return str;
}
