// MakeTerrain.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MakeTerrain.h"

#include "MainFrm.h"
#include "MakeTerrainDoc.h"
#include "MakeTerrainView.h"
#include "OpenglView.h"
#include "DlgLight.h"
#include "DlgConfigMouse.h"
#include "ObjetTroisD.h"
#include "DlgHauteurAlea.h"
#include "DlgFog.h"
#include "DlgAlphaTest.h"
#include "DlgConfigNiveau.h"
#include "DlggSetNbPolygone.h"
#include "DlgNewTerrain.h"





#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Liste des variables externes

extern MATERIEL matLight;
extern MATERIEL matMat;

extern BOOL bFog;
extern BOOL bLight;
extern BOOL bSmooth;
extern BOOL bPivotCam;
extern BOOL bTexture;
extern BOOL bAction;
extern BOOL bFilaire;
extern BOOL bMateriel;
extern Objet * pObjWorld;
extern CTextureListe TextureListe;
extern CShip * pVaisSelected;
extern int NCHUNK;
BOOL bDrawTerrainOnMouse = TRUE;



extern int DessinIdTexture;
extern int DessinIndexTexture;
extern int DrawTerrain;
extern int PinceauType;
extern int DetailIdTexture;
extern int DetailIndexTexture;






int Manip = MANIP_ZOOM;
int Dessin = DESSIN_PINCEAU;



int CoefHauteur		= 10;
int CoefZoom		= 5;
int CoefDep			= 20;
int CoefRotate		= 2;
int TypePlaquage = TEXTURE_NIV_PARTOUT;


CMakeTerrainDoc * pGlobalDoc;
COpenglView * pOpenGlView = NULL;
CMakeTerrainView * p2dView = NULL;



CListShip ShipList;

int TerrainAffichageType		=   TERRAIN_AFFICHAGE_FACETTE;
Objet * PrevObj = NULL;





/////////////////////////////////////////////////////////////////////////////
// CMakeTerrainApp

BEGIN_MESSAGE_MAP(CMakeTerrainApp, CWinApp)
	//{{AFX_MSG_MAP(CMakeTerrainApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_AVANCE, OnAvance)
	ON_COMMAND(ID_MOVE, OnMove)
	ON_COMMAND(ID_ARRONDIR, OnArrondir)
	ON_COMMAND(ID_DRAW, OnDraw)
	ON_COMMAND(ID_MOVE_LUMIERE, OnMoveLumiere)
	ON_COMMAND(ID_MOVE_LUMIERE_Y, OnMoveLumiereY)
	ON_UPDATE_COMMAND_UI(ID_ARRONDIR, OnUpdateArrondir)
	ON_UPDATE_COMMAND_UI(ID_AVANCE, OnUpdateAvance)
	ON_UPDATE_COMMAND_UI(ID_MOVE, OnUpdateMove)
	ON_UPDATE_COMMAND_UI(ID_MOVE_LUMIERE, OnUpdateMoveLumiere)
	ON_UPDATE_COMMAND_UI(ID_MOVE_LUMIERE_Y, OnUpdateMoveLumiereY)
	ON_UPDATE_COMMAND_UI(ID_DRAW, OnUpdateDraw)
	ON_COMMAND(ID_ENABLE_LIGHT, OnEnableLight)
	ON_UPDATE_COMMAND_UI(ID_ENABLE_LIGHT, OnUpdateEnableLight)
	ON_COMMAND(ID_FACETTE, OnFacette)
	ON_UPDATE_COMMAND_UI(ID_FACETTE, OnUpdateFacette)
	ON_COMMAND(ID_MOUSE_CONFIG, OnMouseConfig)
	ON_COMMAND(ID_COLLINE, OnColline)
	ON_UPDATE_COMMAND_UI(ID_COLLINE, OnUpdateColline)
	ON_COMMAND(ID_ROTATE, OnRotate)
	ON_UPDATE_COMMAND_UI(ID_ROTATE, OnUpdateRotate)
	ON_COMMAND(ID_CAMERA, OnCamera)
	ON_UPDATE_COMMAND_UI(ID_CAMERA, OnUpdateCamera)
	ON_COMMAND(ID_DEP_SHIP, OnDepShip)
	ON_UPDATE_COMMAND_UI(ID_DEP_SHIP, OnUpdateDepShip)
	ON_COMMAND(ID_TEXTURE, OnTexture)
	ON_UPDATE_COMMAND_UI(ID_TEXTURE, OnUpdateTexture)
	ON_COMMAND(ID_SELECT_SHIP, OnSelectShip)
	ON_COMMAND(ID_SELECT_TEXTURE, OnSelectTexture)
	ON_COMMAND(ID_AVANCE_AUTO, OnAvanceAuto)
	ON_UPDATE_COMMAND_UI(ID_AVANCE_AUTO, OnUpdateAvanceAuto)
	ON_COMMAND(ID_DEFORMER_TERRAIN, OnDeformerTerrain)
	ON_COMMAND(ID_TERRAIN_FILAIRE, OnTerrainFilaire)
	ON_UPDATE_COMMAND_UI(ID_TERRAIN_FILAIRE, OnUpdateTerrainFilaire)
	ON_COMMAND(ID_COLINE_INVERSE, OnColineInverse)
	ON_UPDATE_COMMAND_UI(ID_COLINE_INVERSE, OnUpdateColineInverse)
	ON_COMMAND(ID_APPLATIR, OnApplatir)
	ON_UPDATE_COMMAND_UI(ID_APPLATIR, OnUpdateApplatir)
	ON_COMMAND(ID_ENABLE_FOG, OnEnableFog)
	ON_UPDATE_COMMAND_UI(ID_ENABLE_FOG, OnUpdateEnableFog)
	ON_COMMAND(ID_SET_MATERIEL, OnSetMateriel)
	ON_COMMAND(ID_ENABLE_MATERIEL, OnEnableMateriel)
	ON_UPDATE_COMMAND_UI(ID_ENABLE_MATERIEL, OnUpdateEnableMateriel)
	ON_COMMAND(ID_WORLD, OnWorld)
	ON_COMMAND(ID_PINCEAU_CIRCLE, OnPinceauCircle)
	ON_UPDATE_COMMAND_UI(ID_PINCEAU_CIRCLE, OnUpdatePinceauCircle)
	ON_COMMAND(ID_PINCEAU_SQUARE, OnPinceauSquare)
	ON_UPDATE_COMMAND_UI(ID_PINCEAU_SQUARE, OnUpdatePinceauSquare)
	ON_COMMAND(ID_LIGHT_INIT, OnLightInit)
	ON_COMMAND(ID_CONFIG_FOG, OnConfigFog)
	ON_COMMAND(ID_TERRAIN_FACETTE, OnTerrainFacette)
	ON_UPDATE_COMMAND_UI(ID_TERRAIN_FACETTE, OnUpdateTerrainFacette)
	ON_COMMAND(ID_TERRAIN_POINT, OnTerrainPoint)
	ON_UPDATE_COMMAND_UI(ID_TERRAIN_POINT, OnUpdateTerrainPoint)
	ON_COMMAND(ID_SELECT_SHIP_BIS, OnSelectShipBis)
	ON_UPDATE_COMMAND_UI(ID_SELECT_SHIP_BIS, OnUpdateSelectShipBis)
	ON_COMMAND(ID_LINEARISER, OnLineariser)
	ON_COMMAND(ID_RANDOM, OnRandom)
	ON_COMMAND(ID_LOAD_MAPPING, OnLoadMapping)
	ON_COMMAND(ID_UPDATE_COLOR, OnUpdateColor)
	ON_COMMAND(ID_CAMERA_RESET, OnCameraReset)
	ON_UPDATE_COMMAND_UI(ID_CAMERA_RESET, OnUpdateCameraReset)
	ON_COMMAND(ID_DRAW_TERRAIN_ON_MOUSSE, OnDrawTerrainOnMousse)
	ON_UPDATE_COMMAND_UI(ID_DRAW_TERRAIN_ON_MOUSSE, OnUpdateDrawTerrainOnMousse)
	ON_COMMAND(ID_SET_CHUNK, OnSetChunk)
	ON_COMMAND(ID_NEW_TERRAIN, OnNewTerrain)
	//}}AFX_MSG_MAP
	// Standard file based document commands
//	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMakeTerrainApp construction

CMakeTerrainApp::CMakeTerrainApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CMakeTerrainApp object

CMakeTerrainApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CMakeTerrainApp initialization

BOOL CMakeTerrainApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CSingleDocTemplate* pDocTemplate;
	
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CMakeTerrainDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
//		RUNTIME_CLASS(CMakeTerrainView));
		RUNTIME_CLASS(COpenglView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it.
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();

	OnSelectShip();
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CMakeTerrainApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CMakeTerrainApp message handlers


BOOL CMakeTerrainApp::OnIdle(LONG lCount) 
{
	// TODO: Add your specialized code here and/or call the base class
	CWinApp::OnIdle(lCount);
    if (pOpenGlView) pOpenGlView->Invalidate (FALSE);
	return TRUE;
}


void CMakeTerrainApp::OnMove() 
{
	// TODO: Add your command handler code here
	Manip = MANIP_MOVE;
}


void CMakeTerrainApp::OnAvance() 
{
	// TODO: Add your command handler code here
	Manip = MANIP_ZOOM;
	
}





void CMakeTerrainApp::OnArrondir() 
{
	// TODO: Add your command handler code here
	Dessin = DESSIN_ARRONDISSEMENT;
	
}


void CMakeTerrainApp::OnDraw() 
{
	// TODO: Add your command handler code here
	Dessin = DESSIN_PINCEAU;

}


void CMakeTerrainApp::OnMoveLumiere() 
{
	// TODO: Add your command handler code here
	Manip = MANIP_MOVE_LUMIERE_XZ;
	
}


void CMakeTerrainApp::OnMoveLumiereY() 
{
	// TODO: Add your command handler code here
	Manip = MANIP_MOVE_LUMIERE_Y;
	
}



void CMakeTerrainApp::OnUpdateArrondir(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck (Dessin == DESSIN_ARRONDISSEMENT);
	
}

void CMakeTerrainApp::OnUpdateAvance(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable (!bPivotCam);
	pCmdUI->SetCheck (Manip == MANIP_ZOOM);
	
}

void CMakeTerrainApp::OnUpdateMove(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable (!bPivotCam);
	pCmdUI->SetCheck (Manip == MANIP_MOVE);
	
}

void CMakeTerrainApp::OnUpdateMoveLumiere(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
pCmdUI->SetCheck (Manip == MANIP_MOVE_LUMIERE_XZ);
	
}

void CMakeTerrainApp::OnUpdateMoveLumiereY(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
pCmdUI->SetCheck (Manip == MANIP_MOVE_LUMIERE_Y);
	
}


void CMakeTerrainApp::OnUpdateDraw(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
pCmdUI->SetCheck (Dessin == DESSIN_PINCEAU);
	
}

void CMakeTerrainApp::OnEnableLight() 
{
	// TODO: Add your command handler code here
	bLight = (bLight) ? FALSE : TRUE;
	
}

void CMakeTerrainApp::OnUpdateEnableLight(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck (bLight);
	
}


void CMakeTerrainApp::OnFacette() 
{
	// TODO: Add your command handler code here
	bSmooth	= (bSmooth) ? FALSE : TRUE;
}

void CMakeTerrainApp::OnUpdateFacette(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck (!bSmooth);
	
}

void CMakeTerrainApp::OnMouseConfig() 
{
	// TODO: Add your command handler code here
	CDlgConfigMouse	Dlg;
	Dlg.Hauteur		= CoefHauteur;
	Dlg.Zoom		= CoefZoom;
	Dlg.Dep			= CoefDep;
	Dlg.Rotate		= CoefRotate;
	
	if (Dlg.DoModal () == IDCANCEL) return;

	CoefHauteur		= Dlg.Hauteur;
	CoefZoom		= Dlg.Zoom;
	CoefDep			= Dlg.Dep;
	CoefRotate		= Dlg.Rotate;
}

void CMakeTerrainApp::OnColline() 
{
	// TODO: Add your command handler code here
	Dessin = DESSIN_COLLINE;
	
}

void CMakeTerrainApp::OnUpdateColline(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck ((Dessin == DESSIN_COLLINE) ? 1 : 0);

	
}


void CMakeTerrainApp::OnRotate() 
{
	// TODO: Add your command handler code here
	Manip = MANIP_ROTATION;
	
}

void CMakeTerrainApp::OnUpdateRotate(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable (!bPivotCam);
	pCmdUI->SetCheck (Manip == MANIP_ROTATION);
	
}


void CMakeTerrainApp::OnCamera() 
{
	// TODO: Add your command handler code here
	bPivotCam = (bPivotCam) ? FALSE : TRUE;
	if (bPivotCam)
	{
		Manip = MANIP_SHIP;
		bDrawTerrainOnMouse = FALSE;
	}
	else
		Manip = MANIP_ROTATION;
}

void CMakeTerrainApp::OnUpdateCamera(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable (pVaisSelected != NULL);
	pCmdUI->SetCheck (bPivotCam	);
}


void CMakeTerrainApp::OnDepShip() 
{
	// TODO: Add your command handler code here
	Manip = MANIP_SHIP;	
	
}

void CMakeTerrainApp::OnUpdateDepShip(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck (Manip == MANIP_SHIP);
}




void CMakeTerrainApp::OnTexture() 
{
	// TODO: Add your command handler code here
	bTexture = (bTexture) ? FALSE : TRUE;
	
}

void CMakeTerrainApp::OnUpdateTexture(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck (bTexture);
	
}

// Charger un vaisseau
void CMakeTerrainApp::OnSelectShip() 
{
	Objet * pObjLoad;
	CTank * pTank;

	// chargement des objets du tank
	pObjLoad = pGlobalDoc->ChargerASEFile ("TANKCORPS.ASE");
	if (pObjLoad == NULL) return;
	
	
	// Cration d'un nouveau tank
	pTank = new CTank (pObjLoad);
	
	
	pObjLoad = pGlobalDoc->ChargerASEFile ("TANKTOURELLE.ASE");
	if (pObjLoad == NULL)
	{
		delete pTank;
		return;
	}
	pTank->objTourelle = pObjLoad;

	
	pObjLoad = pGlobalDoc->ChargerASEFile ("TANKCANON.ASE");
	if (pObjLoad == NULL)
	{
		delete pTank;
		return;
	}

	pTank->objCanon = pObjLoad;

	
	ShipList.AddShip (pTank);

	// Slectionner par defaut ce premier ship
	if (pVaisSelected == NULL) pVaisSelected = (CShip *) pTank;
	pOpenGlView->SetAllShipOnLandscape ();
}



void CMakeTerrainApp::ChargerObjet (CString FileName)
{
	Objet * pObjLoad;
	pObjLoad = pGlobalDoc->ChargerASEFile (FileName);
	if (!pObjLoad) return;

	CShip * pVaisLoad;

	pVaisLoad = new CShip (pObjLoad);
	if (!pVaisLoad)
	{
		delete pObjLoad;
		return;
	}
	
	ShipList.AddShip (pVaisLoad);

	// Slectionner par defaut ce premier ship
	if (pVaisSelected == NULL) pVaisSelected = pVaisLoad;
	
	// Mmoriser l'objet prcedent
	PrevObj = pObjLoad;
	PrevFileNameObject = FileName;

	pOpenGlView->SetAllShipOnLandscape ();
}


// Charger une texture de terrain
void CMakeTerrainApp::OnSelectTexture() 
{
	CString FileName;
	char BASED_CODE Filtre[] = "BMP Files (*.bmp)|*.bmp||";
	
	
	CFileDialog fd (TRUE,NULL,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,Filtre);

	if (fd.DoModal () == IDCANCEL) return ;
	FileName = fd.GetPathName ();

	if (!TextureListe.AddTexture (FileName))
	{
		AfxMessageBox ("Impossible de charger la texture");
		return;
	}

	// Ajouter dans la liste des bitmaps
	CMainFrame * pMain;
	pMain = (CMainFrame *) AfxGetMainWnd ();
	pMain->AddBitmap (FileName);

}


// Prendre le handle d'une texture dans la liste des textures
HBITMAP CMakeTerrainApp :: GetTextureHandle (int index)
{
	CMainFrame * pMain;
	pMain = (CMainFrame *) AfxGetMainWnd ();
	if (!pMain) return NULL;
	return pMain->GetTextureHandle (index);

}


void CMakeTerrainApp::OnAvanceAuto() 
{
	// TODO: Add your command handler code here
	bAction = (bAction) ? FALSE : TRUE;

	if (bAction) pOpenGlView->SetTimer (ID_TIMER_AUTO_AVANCE,10,NULL); 
	else pOpenGlView->KillTimer (ID_TIMER_AUTO_AVANCE); 
	
}

void CMakeTerrainApp::OnUpdateAvanceAuto(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck (bAction);
}



void CMakeTerrainApp::OnDeformerTerrain() 
{
	// TODO: Add your command handler code here
	CDlgHauteurAlea Dlg;
	Dlg.DoModal ();
}


void CMakeTerrainApp::OnColineInverse() 
{
	// TODO: Add your command handler code here
	Dessin = DESSIN_COLLINE_CREUX;
}

void CMakeTerrainApp::OnUpdateColineInverse(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck ((Dessin == DESSIN_COLLINE_CREUX) ? 1 : 0);

}



// Slectionne une texture dans la liste
BOOL CMakeTerrainApp :: SelectTexture (int index)
{
	CTextureInfo * pTexture;
	pTexture = TextureListe.GetTexture (index);
	if (!pTexture)
	{
		AfxMessageBox ("Texture introuvable");
		return FALSE;
	}

	// Prednre l'identifiant de la texture.
	DessinIdTexture = pTexture->GetID ();
	DessinIndexTexture = index;

	return TRUE;
}

// Slectionne une texture dans la liste
BOOL CMakeTerrainApp :: SelectDetailTexture (int index)
{
	CTextureInfo * pTexture;
	pTexture = TextureListe.GetTexture (index);
	if (!pTexture)
	{
		AfxMessageBox ("Texture introuvable");
		return FALSE;
	}

	// Prednre l'identifiant de la texture.
	DetailIdTexture = pTexture->GetID ();
	DetailIndexTexture = index;

	return TRUE;
}



BOOL CMakeTerrainApp :: DeleteTexture (int index)
{
	int IdTextureToDelete;
	CTextureInfo * pTexture;
	pTexture = TextureListe.GetTexture (index);
	if (!pTexture)
	{
		AfxMessageBox ("Texture introuvable");
		return FALSE;
	}

	// Prednre l'identifiant de la texture.
	IdTextureToDelete = pTexture->GetID ();
	
	// Si l'identifiant de la texture est le meme que celui slectionn
	// alors on l'initialise  -1 pour le rednre inutilisable
	if (DessinIdTexture == IdTextureToDelete) DessinIdTexture = -1;
	if (DetailIdTexture == IdTextureToDelete) DetailIdTexture = -1;

	// Cette methode effectue une RAZ de tous les indexs de texture
	// de toute les facettes dont l'identifiant est egale  IdTextureToDelete
	pGlobalDoc->ResetFacetteTexture (IdTextureToDelete);

	// Dtruire la texture
	TextureListe.DeleteTexture (index);
	
	return TRUE;
}



void CMakeTerrainApp::OnApplatir() 
{
	// TODO: Add your command handler code here
	Dessin = DESSIN_APPLATIR;
}

void CMakeTerrainApp::OnUpdateApplatir(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck ((Dessin == DESSIN_APPLATIR) ? 1 : 0);
}

void CMakeTerrainApp::OnEnableFog() 
{
	// TODO: Add your command handler code here
	bFog = (bFog) ? FALSE : TRUE;

	if (bFog)	glEnable (GL_FOG);
	else		glDisable (GL_FOG);
	

	
}

void CMakeTerrainApp::OnUpdateEnableFog(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck (bFog);
	
}

void CMakeTerrainApp::OnSetMateriel() 
{
	// TODO: Add your command handler code here
	CDlgLight Dlg;
	Dlg.SetMaterielInfo (&matMat);
	Dlg.SetView (pOpenGlView);

	Dlg.DoModal ();
}

void CMakeTerrainApp::OnEnableMateriel() 
{
	// TODO: Add your command handler code here
	bMateriel = (bMateriel) ? FALSE : TRUE;

//	if (bMateriel) glEnable (GL_COLOR_MATERIAL);
//	else glDisable (GL_COLOR_MATERIAL);
}

void CMakeTerrainApp::OnUpdateEnableMateriel(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck (bMateriel);
	
}

// Chargement du ciel
void CMakeTerrainApp::OnWorld() 
{
	// TODO: Add your command handler code here
	CString FileName;
	char BASED_CODE Filtre[] = "ASE Files (*.ase)|*.ase||";
	CFileDialog fd (TRUE,NULL,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,Filtre);

	if (fd.DoModal () == IDCANCEL) return;
	FileName = fd.GetPathName ();

	if (pObjWorld) delete pObjWorld;
	pObjWorld = pGlobalDoc->ChargerASEFile (FileName);
	if (!pObjWorld) return;
}

void CMakeTerrainApp::OnPinceauCircle() 
{
	// TODO: Add your command handler code here
	PinceauType = PINCEAU_CIRCLE;
	
}

void CMakeTerrainApp::OnUpdatePinceauCircle(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck (PinceauType == PINCEAU_CIRCLE);
}

void CMakeTerrainApp::OnPinceauSquare() 
{
	// TODO: Add your command handler code here
	PinceauType = PINCEAU_SQUARE;
}

void CMakeTerrainApp::OnUpdatePinceauSquare(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck (PinceauType == PINCEAU_SQUARE);
}


void CMakeTerrainApp :: SetInfo (CString str)
{
	CWnd * pMain;
	pMain = AfxGetMainWnd ();
	if (!pMain) return;
	pMain->SetWindowText (str);
}




void CMakeTerrainApp::OnLightInit() 
{

	CDlgLight Dlg;
	Dlg.SetMaterielInfo (&matLight);
	Dlg.SetView (pOpenGlView);
	Dlg.DoModal ();
	
}


void CMakeTerrainApp::OnConfigFog() 
{
	CDlgFog Dlg;

	Dlg.SetFog (&pOpenGlView->cFog);
	Dlg.SetView (pOpenGlView);
	Dlg.DoModal ();
}



void CMakeTerrainApp::OnTerrainFilaire() 
{
//	bFilaire = (bFilaire) ? FALSE : TRUE;
	TerrainAffichageType = TERRAIN_AFFICHAGE_FIL_DE_FER;
//	glPolygonMode (GL_FRONT,GL_LINE);
}

void CMakeTerrainApp::OnUpdateTerrainFilaire(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
//	pCmdUI->SetCheck (bFilaire);
	pCmdUI->SetCheck ((TerrainAffichageType == TERRAIN_AFFICHAGE_FIL_DE_FER));
	
}

void CMakeTerrainApp::OnTerrainFacette() 
{
	TerrainAffichageType = TERRAIN_AFFICHAGE_FACETTE;
//	glPolygonMode (GL_FRONT,GL_FILL);
}

void CMakeTerrainApp::OnUpdateTerrainFacette(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck ((TerrainAffichageType == TERRAIN_AFFICHAGE_FACETTE));
}

void CMakeTerrainApp::OnTerrainPoint() 
{
	TerrainAffichageType = TERRAIN_AFFICHAGE_POINT;
//	glPolygonMode (GL_FRONT,GL_POINT);
}

void CMakeTerrainApp::OnUpdateTerrainPoint(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck ((TerrainAffichageType == TERRAIN_AFFICHAGE_POINT));
}


void CMakeTerrainApp::OnSelectShipBis() 
{
	// TODO: Add your command handler code here
	ChargerObjet (PrevFileNameObject);
}

void CMakeTerrainApp::OnUpdateSelectShipBis(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable ((PrevObj != NULL));
	
}

void CMakeTerrainApp::OnLineariser() 
{
	pGlobalDoc->Lineariser ();
	p2dView->Invalidate ();
}

void CMakeTerrainApp::OnRandom() 
{
	// TODO: Add your command handler code here
	pGlobalDoc->Random ();
	
	p2dView->Invalidate ();
	pOpenGlView->SetAllShipOnLandscape ();
}


void CMakeTerrainApp::OnLoadMapping() 
{
	int Size;
	float hauteur;
	int i,j;
	BYTE r,g,b;
	CString FileName;
	BOOL bRet = FALSE;
	char BASED_CODE Filtre[] = "bmp Files (*.bmp)|*.bmp||";

	CFileDialog fd (TRUE,NULL,NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,Filtre);

	if (fd.DoModal () == IDCANCEL) return;
	FileName = fd.GetPathName ();

	if (!pGlobalDoc->LoadMapping (FileName))
	{
		AfxMessageBox ("Impossible de charger le mapping");
		return;
	}
	
	// Repositionner les vehicules
	pOpenGlView->SetAllShipOnLandscape ();
	
	// Redessiner les vues
	p2dView->Invalidate ();
}

void CMakeTerrainApp::OnUpdateColor() 
{
	// TODO: Add your command handler code here
	pGlobalDoc->UpdatePointColor ();
	p2dView->Invalidate ();
	
}

void CMakeTerrainApp::OnCameraReset() 
{
	pOpenGlView->ResetView ();
}

void CMakeTerrainApp::OnUpdateCameraReset(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable (!bPivotCam);
}

void CMakeTerrainApp::OnDrawTerrainOnMousse() 
{
	// TODO: Add your command handler code here
	bDrawTerrainOnMouse = (bDrawTerrainOnMouse == TRUE) ? FALSE : TRUE;
	
}

void CMakeTerrainApp::OnUpdateDrawTerrainOnMousse(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->SetCheck (bDrawTerrainOnMouse);
	
}

void CMakeTerrainApp::OnSetChunk() 
{
	// TODO: Add your command handler code here
	CDlggSetNbPolygone Dlg;
	Dlg.SetInfo (pGlobalDoc->GetTotalPoint (),NCHUNK);
	if (Dlg.DoModal () == IDCANCEL) return;
	NCHUNK = Dlg.Nchunk;

	
}

void CMakeTerrainApp::OnNewTerrain() 
{
	// TODO: Add your command handler code here
	CDlgNewTerrain Dlg;
	if (Dlg.DoModal () == IDCANCEL) return;
	pGlobalDoc->NewTerrain (Dlg.Npoint);
	pOpenGlView->ResetView ();
	pOpenGlView->SetAllShipOnLandscape ();
	p2dView->Invalidate (TRUE);
}
